pro installTestScript

;ECHAIM examples
;Run this script and check the output against the expected output file provided.
;This is to ensure that you're installation of the ECHAIM model is correct.

lat = [70,80]
lon = [210,220]
t = julday([5,9],[6,1],[1988,2012],[12,0],[1,0],[0,0])
altProf = (findgen(10)*100d0)+100
altPath = [200,210]

print, "Begin running model for all outputs"
print, "Run #1"
;running for NmF2, HmF2, HmF1, Profile
a = echaim(lat,lon,t, altProf)

print, "Run #2"
;running for NmF2, Profile (storm)
b = echaim(lat,lon,t,altProf,/STORM_nmF2)

print, "Run #3"
;Satellite path
c = echaim(lat,lon,t,altPath,/satellite, /precip)

print, "Run #4"
;Satellite path storm
d = echaim(lat,lon,t,altPath,/satellite,/STORM_nmF2)

print, "NmF2: "
print, a.NmF2, format="(f20.5)"

print, "NmF2 Storm: "
print, b.NmF2, format="(f20.5)"

print, "HmF2: "
print, a.HmF2, format="(f8.3)"

print, "HmF1: "
print, a.HmF1, format="(f8.3)"

print, "Density Profile: "
print, a.dens, format="(f20.5)"

print, "Density Profile Storm: "
print, b.dens, format="(f20.5)"

print, "Satellite Path: "
print, c.dens, format="(f20.5)"

print, "Satellite Path Storm: "
print, d.dens, format="(f20.5)"

end