;routine to read the test suite outputs (Matlab, C, and IDL)
;and do comparisons 

pro testCompare

testsuite

dir = "C:\Users\amccaffr\Documents\CHAIM\C_Project\ECHAIM-C\etc\"

mat = 1
c = 0

;open files
openr, lunIDL, dir + "outputIDL.dat", /get_lun
if c then openr, lunC, dir + "ECHAIMOutput.dat", /get_lun
if mat then openr, lunMat, dir + "outputMat.dat", /get_lun

;read amount of data from the files
li = dblarr(2)
if c then lc = li
if mat then lm = li

readf, lunIDL, li
if c then readf, lunc, lc
if mat then readf, lunMat, lm

if c then if (li[0] ne lc[0]) then print, "Error"
if c then if (li[1] ne lc[1]) then print, "Error"
if mat then if (li[0] ne lm[0]) then print, "Error"
if mat then if (li[1] ne lm[1]) then print, "Error"
if mat and c then if (lm[0] ne lc[0]) then print, "Error"
if mat and c then if (lm[1] ne lc[1]) then print, "Error"

;create data arrays and read the data
arrIDL = dblarr(li[0],li[1]) + !values.d_nan
if c then arrC = arrIDL
if mat then arrMat = arrIDL

readf, lunIDL, arrIDL
if c then readf, lunC, arrc
if mat then readf, lunMat, arrMat

free_lun, lunIDL
if c then free_lun, lunC
if mat then free_lun, lunMat


;compare the data
!P.multi=[0,1,3]

if c then print, "Mean % difference IDL-C: ", mean(abs(arrIDL-arrC)/arrIDL,/nan)*100d0, stddev(abs(arrIDL-arrC)/arrIDL,/nan)*100d0
if c then print, "Max % difference IDL-C: ", max(abs((arrIDL-arrC)/arrIDL)*100d0,/nan)

if c then begin
  a = where(finite(arrIDL) eq 0)
  b = where(Finite(arrC) eq 0)
  
  if total(a-b) ne 0 then print, "Uneven NaNs"
  
endif

if c then cgplot, abs((arrIDL-arrC)/arrIDL)*100d0

print,''
print,''
if mat then print, "Mean difference IDL-Mat: ", mean(abs(arrIDL-arrMat),/nan), stddev(abs(arrIDL-arrMat),/nan)
if mat then print, "Mean % difference IDL-Mat: ", mean(abs(arrIDL-arrMat)/arrIDL,/nan)*100d0, stddev(abs(arrIDL-arrMat)/arrIDL,/nan)*100d0
if mat then print, "Max % difference IDL-Mat: ", max(abs((arrIDL-arrMat)/arrIDL)*100d0,/nan)

if mat then begin
  a = where(finite(arrIDL) eq 0)
  b = where(Finite(arrMat) eq 0)

  if total(a-b) ne 0 then print, "Uneven NaNs"

endif

if mat then p = plot(abs((arrIDL-arrMat)/arrIDL)*100d0)

if mat*c eq 1 then begin
  print,''
  print,''
  
  print, "Mean difference C-Mat: ", mean(abs(arrC-arrMat),/nan), stddev(abs(arrC-arrMat),/nan)
  print, "Mean % difference C-Mat: ", mean(abs(arrC-arrMat)/arrC,/nan)*100d0, stddev(abs(arrC-arrMat)/arrC,/nan)*100d0
  print, "Max % difference C-Mat: ", max(abs((arrC-arrMat)/arrC)*100d0,/nan)
  
  a = where(finite(arrC) eq 0)
  b = where(Finite(arrMat) eq 0)

  if total(a-b) ne 0 then print, "Uneven NaNs"
endif

if c*mat then cgplot, abs((arrC-arrMat)/arrC)*100d0

;use print for breakpoint
print,''

end
