function calc_CHAIM_model_parameters_for_bottomside,MLON_in,MLAT_in, jul_day_in,slz_in,f107_in,SSN_in,modip_in,inclen_in,kp_in,ig_in,ig12_in,f107_81_in,f107_365_in,dip_tilt,MLT_in,lt_hour_in,geo_lat_in,jul_ut_in, AE_in

; MLT in hours.
; MLAT in degrees.
; F107 in flux units.
; jul_day_in the julian local time stamp associated with the data.

;jul_ut_hour = jul_ut_in-floor(jul_ut_in)

;mlt_in = lt_hour_in
;mlat_in = geo_lat_in

MLT_degrees = MLT_in/24.0*360.0
MLON_u = MLT_degrees
;MLON_u = MLON_in

;f107_in_temp = (f107_in+f107_81_in)/2.0 ;mean of 27-day and 81-day smoothed f10.7 fluxes
f107_in_temp = f107_81_in
f107_u = f107_in_temp

F1 = f107_u
F2 = AE_in
;F2 = (f107_u)^(1.0/1.9)
;F1 = ALOG10(f107_in)
;F2 = (1.0/f107_in)

caldat, jul_day_in, monthin,dayin,yearin,hourin,minutein,secondin
cos_factor = cos((90.0-MLAT_in)*!PI/45.0)
;cos_factor = cos(MLAT_in*!PI/180.0)
DoY_in = jul_day_in-julday(01,01,yearin,00,00,00)
DoY_in=float((DoY_in));float(floor(DoY_in))
;cos_slz = cos(slz_in*!PI/180.0)
cos_slz = (cos(slz_in*!PI/180.0)+1.0);^0.59
sin_slz =(sin(slz_in*!PI/180.0)+1.0);^3.00
sin_tilt = sin(dip_tilt)
cos_tilt = cos(dip_tilt)




for a = 0, 5 do begin
a1 = a
for b = 0,min([a,5]) do begin
b1 = b

Plm = Legendre(cos_factor,a1,b1)

if b1 eq 0 then begin
p7x = F1*Plm*sin((DoY_in*(2.0*!PI))/(365.25*2.0))^2.0*cos(!PI*b1*MLON_u/180.0)

;p11x = f2*Plm*sin((DoY_in*(2.0*!PI))/(365.25*2.0))^2.0*cos(!PI*b1*MLON_u/180.0)

;p12x = sin(dip_tilt)*f1*Plm*cos(!PI*b1*MLON_u/180.0)
;p13x = sin(dip_tilt)*f2*Plm*cos(!PI*b1*MLON_u/180.0)


pppx = [[p7x]];,[p12x]];,[p11x],[p13x]]
endif else begin
p5x = f1*Plm*sin((DoY_in*(2.0*!PI))/(365.25*2.0))^2.0*sin(!PI*b1*MLON_u/180.0)
p7x = f1*Plm*sin((DoY_in*(2.0*!PI))/(365.25*2.0))^2.0*cos(!PI*b1*MLON_u/180.0)

;p9x = f2*Plm*sin((DoY_in*(2.0*!PI))/(365.25*2.0))^2.0*sin(!PI*b1*MLON_u/180.0)
;p11x = f2*Plm*sin((DoY_in*(2.0*!PI))/(365.25*2.0))^2.0*cos(!PI*b1*MLON_u/180.0)

;p12x = sin(dip_tilt)*f1*Plm*sin(!PI*b1*MLON_u/180.0)
;p13x = sin(dip_tilt)*f1*Plm*cos(!PI*b1*MLON_u/180.0)
;p14x = sin(dip_tilt)*f2*Plm*sin(!PI*b1*MLON_u/180.0)
;p15x = sin(dip_tilt)*f2*Plm*cos(!PI*b1*MLON_u/180.0)

pppx = [[p5x],[p7x]];,[p12x],[p13x]];,[p9x],[p11x],[p14x],[p15x]]
endelse


for c = 0,2 do begin
;carr = [0.2,0.25,(1.0/3.0),0.5,1.0]
;carr = [0.25,(1.0/3.0),0.5,1.0]
carr = [(1.0/3.0),0.5,1.0]
c1 = carr(c)

if b1 eq 0 then begin
p7 = f1*Plm*sin((DoY_in*(2.0*!PI))/(365.25*c1))*cos(!PI*b1*MLON_u/180.0)
p8 = f1*Plm*cos((DoY_in*(2.0*!PI))/(365.25*c1))*cos(!PI*b1*MLON_u/180.0)


;p11 = f2*Plm*sin((DoY_in*(2.0*!PI))/(365.25*c1))*cos(!PI*b1*MLON_u/180.0)
;p12 = f2*Plm*cos((DoY_in*(2.0*!PI))/(365.25*c1))*cos(!PI*b1*MLON_u/180.0)


ppp = [[p7],[p8]];,[p11],[p12]]
endif else begin

p5 = f1*Plm*sin((DoY_in*(2.0*!PI))/(365.25*c1))*sin(!PI*b1*MLON_u/180.0)
p6 = f1*Plm*cos((DoY_in*(2.0*!PI))/(365.25*c1))*sin(!PI*b1*MLON_u/180.0)
p7 = f1*Plm*sin((DoY_in*(2.0*!PI))/(365.25*c1))*cos(!PI*b1*MLON_u/180.0)
p8 = f1*Plm*cos((DoY_in*(2.0*!PI))/(365.25*c1))*cos(!PI*b1*MLON_u/180.0)

;p9 = f2*Plm*sin((DoY_in*(2.0*!PI))/(365.25*c1))*sin(!PI*b1*MLON_u/180.0)
;p10 = f2*Plm*cos((DoY_in*(2.0*!PI))/(365.25*c1))*sin(!PI*b1*MLON_u/180.0)
;p11 = f2*Plm*sin((DoY_in*(2.0*!PI))/(365.25*c1))*cos(!PI*b1*MLON_u/180.0)
;p12 = f2*Plm*cos((DoY_in*(2.0*!PI))/(365.25*c1))*cos(!PI*b1*MLON_u/180.0)

ppp = [[p5],[p6],[p7],[p8]];,[p9],[p10],[p11],[p12]]
endelse

;aa = where(finite(ppp,/NAN),pppcnt)
;
;if pppcnt gt 0 then begin
;print, 'the'
;endif

if c lt 1 then begin
ppps = [ppp]
endif else begin
ppps = [[ppps],[ppp]]
endelse

endfor

if b lt 1 then begin
pppss = [[ppps],[pppx]]
endif else begin
pppss = [[pppss],[ppps],[pppx]]
endelse

endfor

if a lt 1 then begin
pppsss = [pppss]
endif else begin
pppsss = [[pppsss],[pppss]]
endelse

endfor

;pppsss = [[pppsss],[F107_in*cos_slz],[F107_in^2.0*cos_slz],[sqrt(F107_in)*cos_slz],[sqrt(F107_in)*sin_slz],[F107_in*sin_slz],[ig_in*sin_slz],[ig_in*cos_slz],[ig_in],[ig_in^2.0],[sin_slz],[cos_slz],[cos_slz*cos_tilt],[sin_tilt],[cos_tilt],[cos_slz*sin_tilt]]
pppsss = [[pppsss],[sin_slz],[cos_slz],[sin_tilt],[cos_tilt],[cos_slz*cos_tilt],[cos_slz*sin_tilt],[sin_slz*cos_tilt],[sin_slz*sin_tilt],[slz_in],[AE_in*cos(MLAT_in*!PI/180.0)],[AE_in*sin(MLAT_in*!PI/180.0)]]


arg = 1.0

outsarr = {vars: pppsss, kpindexs:arg, kpcounts:arg, kp_out:arg}

return, outsarr


end