function dRegionPert, rootDir, lat, sza, f107, doy, alts, mapMode
; lat= Scalar of Latitudes (Degrees North)
; sza = Scalar of Solar Zenith Angle (Degrees)
; f107 = Scalar of F10.7 Flux (sfu)
; doy = Scalar of Day of Year (days)
; alts = Vector of Altitudes (km)
; All inputs can be scalars or vectors

;load the save file


;set some limits
a = where(lat lt 60.0)
if a[0] ne -1 then lat[a] = 60.0
a = where(sza gt 130.0)
if a[0] ne -1 then sza[a] = 130.0
a = where(f107 gt 200.0)
if a[0] ne -1 then f107[a] = 200.0
a = where(f107 lt 75.0)
if a[0] ne -1 then f107[a] = 75.0

; Identify applicable range:
checkalts = where(alts lt 150.0 and alts gt 50.0);

case mapMode of 
  2: begin ;map mode
    print, '2'
    break
  end
  
  1: begin ; profile
    print, '1'
    break
  end
  
  0: begin ;sat mode
    ;Define output vector:
    output = fltarr(n_elements(alts));
    
    ;ninterpolate expects the values to be the indices, not the values, so we need to convert the values
    ;to where they would be each array
    ;eg on the f10.7 axis lets say [array index,value] -- [10,70], [11,80]. If we want to interpolate to F10.7 eq 75, then
    ; we pass ninterpolate f107 = 10.5
    
    ;Interpolate FIRI2018 data to requested data points:
    ;pert_dens_temp = ninterpolate([w,v,x,y,z],denspertextra,f107,doy,sza,lat,alts[checkalts]);
    
    ;Fill applicable range with data:
    ;output(checkalts) = pert_dens_temp(1,1,1,1,:);
    break
  end
endcase

end