function ECHAIM_wrapper_pert, lat_temp,lon_temp,dates_use

; lat_temp: The geographic latitude of the point of interest
; lon_temp: The geographic longitude of the point of interest
; dates_use: The UTC Julian times of interest (can use JULDAY(MONTH,DAY,YEAR,HOUR,MINUTE,SECOND) in place of this variable)

; The lat_temp, lon_temp, and dates_use variables can be vectors or single values but must all be of the same length.

;mlat_out_arr = fltarr(n_elements(lat_temp))
;mlon_out_arr = fltarr(n_elements(lat_temp))
NmF2_out_arr = fltarr(n_elements(lat_temp))
;lt_out_arr = dblarr(n_elements(lat_temp))
hours_lt_out_arr = fltarr(n_elements(lat_temp))


model_dir = 'C:\Users\p8anp\Desktop\E-CHAIM_For_Helmholtz'

model_file = 'perturb_model_save_file(Old Ap, Dst, and AE Functions)(sin-cos_dips)(5-3)(5-4-6 base model-Less_After-).sav'

cd, model_dir
restore, model_file

alts_use = fltarr(n_elements(lat_temp))
alts_use(0:*) = 300.0

lt_struct = lt_and_mlat_calc_david_for_monthly_medians(lat_temp, lon_temp, alts_use,dates_use)
resc_kp = lt_struct.J
resc_SSN = lt_struct.H
resc_F107 = lt_struct.G
resc_sza = lt_struct.F
resc_inclen = lt_struct.E
resc_modip = lt_struct.D
resc_mlon = lt_struct.C
resc_mlat = lt_struct.B
resc_jul_lt = lt_struct.K
resc_hour_lt = lt_struct.A
resc_ig = lt_struct.L
resc_ig12 = lt_struct.M
F107_81 = lt_struct.N
F107_365 = lt_struct.O
mmlt = lt_struct.P
dipole_tilts = dipole_tilt_interface(dates_use)


dst_data = read_dst_files('C:\Users\p8anp\Desktop\E-CHAIM_For_Helmholtz')
int_dst_ref = dst_data.(0)
dst_juls_ref = dst_data.(1)
int_Q_ref = dst_data.(2)
dst_ref = dst_data.(3)
Q_ref = dst_data.(4)
just_dst_juls_ref = dst_data.(5)

dir_kp_ap_SSN = 'C:\Users\p8anp\Desktop\E-CHAIM_For_Helmholtz\KP_AP'
kp_file_data = read_all_kp_files(dir_kp_ap_SSN)
ap_ref = kp_file_data.ap_hres
kp_ref_jul = kp_file_data.jul_hres
kp_ref = kp_file_data.kp_hres
ap_param = integrate_geomag_param(0.85,kp_ref_jul,ap_ref)
ap_int_ref = ap_param(0:*,0)
jul_int_ap_ref = ap_param(0:*,1)

just_Q = interpol(Q_ref,just_dst_juls_ref,dates_use)
just_dst = interpol(dst_ref,just_dst_juls_ref,dates_use);interpol(dst_ref,just_dst_juls_ref+(5.0/24.0),dates_use)
just_dst = just_dst
; <----- Make sure just_dst is what you think it is.


AE_ref_struct = read_AE_index_files('AE 1940-2016.txt','C:\Users\p8anp\Desktop\E-CHAIM_For_Helmholtz\AE Indices')
AE_ref = AE_ref_struct.E
AE_juls = AE_ref_struct.I

AE_param = integrate_geomag_param(0.95,AE_juls,AE_ref)
AE_int_ref = AE_param(0:*,0)
jul_int_AE_ref = AE_param(0:*,1)
int_AE = interpol(AE_int_ref,jul_int_AE_ref,dates_use)


int_dst = interpol(int_dst_ref,dst_juls_ref,dates_use)
int_Q = interpol(int_Q_ref,dst_juls_ref,dates_use) 
int_ap = interpol(ap_int_ref,jul_int_ap_ref,dates_use)
just_ap = interpol(ap_ref,kp_ref_jul,dates_use)
int_ap_5 = interpol(ap_int_ref,jul_int_ap_ref+(5.0/24.0),dates_use)
int_Q_5 = interpol(int_Q_ref,dst_juls_ref+(5.0/24.0),dates_use)

;aaarrr_ut = calc_CHAIM_model_parameters_for_lt_seperation_365_81_perturb(resc_mlon,resc_mlat, dates_use,resc_sza,resc_F107,resc_SSN,resc_modip,resc_inclen,resc_kp,resc_ig,resc_ig12,F107_81,F107_365,int_dst,int_Q,int_ap,dipole_tilts,int_ap_5,int_Q_5,just_ap,just_dst,just_Q,int_AE,mmlt)
aaarrr_ut = calc_CHAIM_model_parameters_for_lt_seperation_365_81_perturb(resc_mlon,resc_mlat, dates_use,resc_sza,resc_F107,resc_SSN,resc_modip,resc_inclen,resc_kp,resc_ig,resc_ig12,F107_81,F107_365,int_dst,int_Q,int_ap,dipole_tilts,int_ap_5,int_Q_5,just_ap,just_dst,just_Q,int_AE,mmlt)
aaarrr_ut = aaarrr_ut.vars

caldat,dates_use,rescmonth,rescday,rescyear,reschour,rescminute,rescsecond
hour_lt = (julday(rescmonth,rescday,rescyear,reschour,rescminute,rescsecond)-julday(rescmonth,rescday,rescyear,00,00,00))*24.0
;hour_lt = mmlt

for fab = 0L, n_elements(lat_temp)-1L do begin

bottom_index = floor(hour_lt(fab)-0.5)
top_index = ceil(hour_lt(fab)-0.5)
if bottom_index lt 0 then bottom_index = 23
if top_index ge 24 then top_index = 0

bottom_hour = floor(hour_lt(fab)-0.5)+0.5
top_hour = ceil(hour_lt(fab)-0.5)+0.5
weight_top = abs(1.0-(top_hour-hour_lt(fab)))
weight_bottom = abs(1.0-(hour_lt(fab)-bottom_hour))

flapjacks_lower = model_flapjacks(bottom_index,0:*)
model_par_lower = transpose(flapjacks_lower)
NmF2_model_made_ut_lower = (total(aaarrr_ut(fab,0:*)*model_par_lower)+constants_out(bottom_index))

flapjacks_upper = model_flapjacks(top_index,0:*)
model_par_upper = transpose(flapjacks_upper)
NmF2_model_made_ut_upper = (total(aaarrr_ut(fab,0:*)*model_par_upper)+constants_out(top_index))

NmF2_model_made_ut=(NmF2_model_made_ut_lower*weight_bottom) + (NmF2_model_made_ut_upper*weight_top)

NmF2_out_arr(fab) = NmF2_model_made_ut
endfor

outs_struct = {A:resc_mlon, B:resc_mlat, C:NmF2_out_arr, D:resc_jul_lt, E:hour_lt,F:resc_kp,G:int_dst,H:int_Q,I:int_ap, J:just_ap}

return, outs_struct

end