pro energyFluxModel,mlts, mlats, AEs, isae, dir, outEnergy, outFlux

; Dumb CD to model reference data save file
if isae then begin
  restore, dir + 'GUVI_Fits.sav'
endif else begin
  restore, dir + 'GUVI_Fits_PC.sav'
endelse

; My where that did wierd things: (I need this to work but it's being wierd)
g = where(finite(output_gridded_flux) eq 0,cnt)
if cnt gt 0 then output_gridded_flux(g) = 0.0
f = where(finite(output_gridded_energy) eq 0,cnt)
if cnt gt 0 then output_gridded_energy(f) = 0.0

; Take the average between the top and bottom of the AE bins:
AErefs = (AEbins+AEbinstop)/2.0

; Pre-define output arrays: 
outEnergy = fltarr(n_elements(AEs))
outFlux = fltarr(n_elements(AEs))
AE1 = fltarr(n_elements(AEs)) ; Not necessary, but was useful for diagnostics
AE2 = fltarr(n_elements(AEs)) ; Not necessary, but was useful for diagnostics
out_energies1 = fltarr(n_elements(AEs)) ; Not necessary, but was useful for diagnostics
out_energies2 = fltarr(n_elements(AEs)) ; Not necessary, but was useful for diagnostics
out_fluxs1 = fltarr(n_elements(AEs)) ; Not necessary, but was useful for diagnostics
out_fluxs2 = fltarr(n_elements(AEs)) ; Not necessary, but was useful for diagnostics

; Loop over all input data triplets:
for i = 0L,N_elements(mlts)-1L do begin
  
  AE = AEs(i) ; Select an AE value
  
  if isae then begin
    ;Limit AE values to 1300nT
    if AE gt 1300d0 then AE = 1300d0
  endif else begin
    ;limit PC
    if AE gt 13d0 then AE = 13d0
    if AE lt -7d0 then AE = -7d0
  endelse
  
  AErefs1 = AErefs ; Define temporary AE Reference vector
  min1 = min(abs(AErefs1-AE),minloc1,/nan); Find closest reference AE point to selected AE value
  AErefs1(minloc1) = 1000000.0; set closest reference AE to ridiculously high value
  min2 = min(abs(AErefs1-AE),minloc2,/nan); Find second closest reference AE point to selected AE value
  
  AE1(i) = AErefs(minloc1); Find AE value for closest reference AE
  AE2(i) = AErefs(minloc2); Find AE value for second closest reference AE
  
  ;C interpolation method
  ;correct mlt edges
  outmlts[0,*] -= 24.0
  outmlts[-1,*] += 24.0
  
  ;find mlt mlat indices in coordinate arrays
  t = abs(outmlts[*,0] - mlts[i])
  m = min(t,xt1)
  x1 = outmlts[xt1,0]
  t[xt1] = 1e6
  m = min(t,xt2)
  x2 = outmlts[xt2,0]
  
  t = abs(outmlats[0,*] - mlats[i])
  m = min(t,yt1)
  y1 = outmlats[0,yt1]
  t[yt1] = 1e6
  m = min(t,yt2)
  y2 = outmlats[0,yt2]
  
  ;get energy and flux values
  e111 = output_gridded_energy[xt1,yt1,minloc1]
  e112 = output_gridded_energy[xt1,yt1,minloc2]
  f111 = output_gridded_flux[xt1,yt1,minloc1]
  f112 = output_gridded_flux[xt1,yt1,minloc2]
  e121 = output_gridded_energy[xt1,yt2,minloc1]
  e122 = output_gridded_energy[xt1,yt2,minloc2]
  f121 = output_gridded_flux[xt1,yt2,minloc1]
  f122 = output_gridded_flux[xt1,yt2,minloc2]
  e211 = output_gridded_energy[xt2,yt1,minloc1]
  e212 = output_gridded_energy[xt2,yt1,minloc2]
  f211 = output_gridded_flux[xt2,yt1,minloc1]
  f212 = output_gridded_flux[xt2,yt1,minloc2]
  e221 = output_gridded_energy[xt2,yt2,minloc1]
  e222 = output_gridded_energy[xt2,yt2,minloc2]
  f221 = output_gridded_flux[xt2,yt2,minloc1]
  f222 = output_gridded_flux[xt2,yt2,minloc2]
  
  ;do the interpolation
  out_energies1(i) = (1.0 / ((x2 - x1) * (y2 - y1))) * $
    (e111[0] * (x2 - mlts[i]) * (y2 - mlats[i]) + $
    e211[0] * (mlts[i] - x1) * (y2 - mlats[i]) + $
    e121[0] * (x2 - mlts[i]) * (mlats[i] - y1) + $
    e221[0] * (mlts[i] - x1) * (mlats[i] - y1))
  out_energies2(i) = (1.0 / ((x2 - x1) * (y2 - y1))) * $
    (e112[0] * (x2 - mlts[i]) * (y2 - mlats[i]) + $
    e212[0] * (mlts[i] - x1) * (y2 - mlats[i]) + $
    e122[0] * (x2 - mlts[i]) * (mlats[i] - y1) + $
    e222[0] * (mlts[i] - x1) * (mlats[i] - y1))
  out_fluxs1(i) = (1.0 / ((x2 - x1) * (y2 - y1))) * $
    (f111[0] * (x2 - mlts[i]) * (y2 - mlats[i]) + $
    f211[0] * (mlts[i] - x1) * (y2 - mlats[i]) + $
    f121[0] * (x2 - mlts[i]) * (mlats[i] - y1) + $
    f221[0] * (mlts[i] - x1) * (mlats[i] - y1))
  out_fluxs2(i) = (1.0 / ((x2 - x1) * (y2 - y1))) * $
    (f112[0] * (x2 - mlts[i]) * (y2 - mlats[i]) + $
    f212[0] * (mlts[i] - x1) * (y2 - mlats[i]) + $
    f122[0] * (x2 - mlts[i]) * (mlats[i] - y1) + $
    f222[0] * (mlts[i] - x1) * (mlats[i] - y1))
  
  ;if AE < 10 set out energy and flux to 0? 
  
  ; Set NANs to zero:
  if finite(out_energies1(i),/nan) or out_energies1(i) lt 0.0 then out_energies1(i) = 0.0
  if finite(out_energies2(i),/nan) or out_energies2(i) lt 0.0 then out_energies2(i) = 0.0
  if finite(out_fluxs1(i),/nan) or out_fluxs1(i) lt 0.0 then out_fluxs1(i) = 0.0
  if finite(out_fluxs2(i),/nan) or out_fluxs2(i) lt 0.0 then out_fluxs2(i) = 0.0
  
  ; Interpolate between upper and lower references:
  outEnergy(i) = double(out_energies1(i) + (AE-AE1(i))*(out_energies2(i)-out_energies1(i))/(AE2(i)-AE1(i)))
  outFlux(i) = double(out_fluxs1(i) + (AE-AE1(i))*(out_fluxs2(i)-out_fluxs1(i))/(AE2(i)-AE1(i)))

endfor
end