function enhanced_eregion_profile_generator_DT,date,utc,geo_lat,geo_lon,ener_mean,eflux_mean,ap_daily,$
          f107_daily,f107_80day,alt_arr=alt_arr,espec_gamma=espec_gamma,kappa_op=kappa_op
  
  ;utc (hours)
  ;geo_lat,geo_lon (degrees)
  ;ener_mean (keV)
  ;eflux_mean (erg/s/cm^2)
  ;ap_daily (daily AP)
  ;f107_daily (daily F10.7)
  ;f107_80day (80-day F10.7 average)
  ;alt_arr (altitude array - km)
  
  if (keyword_set(alt_arr) eq 1) then echaim_alt_arr=alt_arr else echaim_alt_arr=findgen(176)/175*350+50
  erg_to_ev=6.2415e11
  erg_to_j=1e-7
  j_to_ev=6.242e18
  if (keyword_set(espec_gamma) eq 0) then espec_gamma=1
  if (keyword_set(kappa_op) eq 0) then kappa_op=0
  
  lfit2=[0.954305,0.293660,0.000263184]
;  echaim_data=echaim_wrapper_nmf2_hmf2_combined_2018_new(geo_lat,geo_lon,$
;      julday(fix(strmid(date,0,2)),fix(strmid(date,2,2)),fix(strmid(date,4,4)),$
;      fix(utc),fix((utc-fix(utc))*60.0),round(((utc-fix(utc))*60.0-fix((utc-fix(utc))*60.0))*60.0)),$
;      echaim_alt_arr,/storm_nmf2)
;  echaim_dens=echaim_data.dens
;  echaim_dens=echaim_dens[*]
;  if ((ener_mean le 1e-2) or (eflux_mean le 1e-2)) then return,{alt:echaim_alt_arr,eden:echaim_dens}
  atm_data=nrlmsise00_arr(date,utc,echaim_alt_arr,geo_lat,geo_lon,f107_daily=f107_daily,$
      f107_3month=f107_80day,ap_daily=ap_daily)
  Ec=ener_mean
  if (espec_gamma eq 1) then Ec=ener_mean/2.0
  if (espec_gamma eq 2) then Ec=lfit2[2]*ener_mean^2+lfit2[1]*ener_mean+lfit2[0]
  if (kappa_op eq 1) then Ec=ener_mean*(espec_gamma-2)/(2.0*espec_gamma)
  Ec=Ec[0]

  espec=energy_spectrum(Ec,espec_gamma,[0.1,1000.0],n_elem=1000,log_op=1,kappa_op=kappa_op)
  norm_flux=espec.flux
  ener_arr=espec.energy
  eflux=eflux_mean*erg_to_ev/1000.0
  qh2=echaim_alt_arr
  q_arr=fltarr(n_elements(ener_arr),n_elements(qh2))
  for ie=0,n_elements(ener_arr)-1 do begin
     imono_rate=eion_rate_fang2010(geo_lat,ener_arr[ie],norm_flux[ie]*eflux,atm_data)
     q_arr[ie,*]=imono_rate
  endfor
  qtot=fltarr(n_elements(qh2))
  for ih=0,n_elements(qh2)-1 do begin
     iqarr=q_arr[*,ih]
     qtot[ih]=int_tabulated(ener_arr,iqarr)
  endfor
  alpha=4.3e-6*exp(-2.42e-2*qh2)+8.16e12*exp(-0.524*qh2);1.3e-6*exp(-1.42e-2*qh2)+8.16e12*exp(-0.524*qh2);
  ;qed=echaim_dens
  ;new_ne=sqrt(Qtot/alpha+(qed/1e6)^2)*1e6
  Qtot_alpha = Qtot/alpha
  ;return,{alt:echaim_alt_arr,eden:new_ne}
  return,{alt:echaim_alt_arr,delta_dens:Qtot_alpha,Qtot:Qtot,alpha:alpha}
  
end