;This function will get the E-CHAIM version number from the 
;ECHAIM.version file
;Inputs:
;dir = the directory that the version file is in
function getVersion, dir

vFile = dir + path_sep() + "ECHAIM.version"

;make sure the file exists, if not, return -1
if file_test(vFile) eq 0 then return, -1

;read the file
data = ''
openr, lun, vFile, /get_lun
readf, lun, data
close, lun
free_lun, lun

;find where the version number is in the string
p = strpos(strmid(data,6,7,/reverse_offset), 'v')
v = strmid(data,6-p-1,7-p-1,/reverse_offset)

return, v

end